// EnumFontFamTest2.cpp
// CC BY
#ifndef UNICODE
    #define UNICODE
#endif
#include <windows.h>
#include <set>
#include <string>
#include <cstdio>

std::set<std::wstring> elfFullNames;

INT CALLBACK EnumFontFamExProc(
    const ENUMLOGFONTEXW *  lpelfe,
    const TEXTMETRICW *     lpntme,
    DWORD                   FontType,
    LPARAM                  lParam)
{
    static int no = 0;
    std::printf("#%d: ", ++no);
    std::printf("elfFullName: \"%S\", ", lpelfe->elfFullName);
    std::printf("elfStyle: \"%S\", ", lpelfe->elfStyle);
    std::printf("lfFaceName: \"%S\", ", lpelfe->elfLogFont.lfFaceName);
    std::printf("lfCharSet: %d\n", lpelfe->elfLogFont.lfCharSet);
    elfFullNames.insert(lpelfe->elfFullName);
    return TRUE;
}

int main(void)
{
    HDC hdc = GetDC(NULL);
    SetGraphicsMode(hdc, GM_ADVANCED);

    LOGFONTW lf = { 0 };
    lf.lfCharSet = DEFAULT_CHARSET;
    lf.lfPitchAndFamily = 0;
    memcpy(lf.lfFaceName, L"Tahoma", 12);

    EnumFontFamiliesExW(hdc, &lf, (FONTENUMPROCW)EnumFontFamExProc, 0, 0);

    bool bad = elfFullNames.size() <= 1;
    if (bad)
        std::printf("bad\n");
    else
        std::printf("good\n");

    return 0;
}
